/*
  ATLACL.cpp 
*/

#include <atlsecurity.h>
#include <iostream>

using namespace std;

void main(){

    try {
        //The user accounts
        CSid sidBlake("Northwindtraders\\blake");
        CSid sidAdmin = Sids::Admins();
        CSid sidGuests = Sids::Guests();

        // Vytvome ACL a naplnme jej polokami ACE.
        // Vimnte si, e odeprac ACE je definovna ped povolujcmi.
        CDacl dacl;
        dacl.AddDeniedAce(sidGuests, GENERIC_ALL);
        dacl.AddAllowedAce(sidBlake, GENERIC_READ);
        dacl.AddAllowedAce(sidAdmin, GENERIC_ALL);

        // Vytvoen popisovae zabezpeen a jeho atribut.
        CSecurityDesc sd;
        sd.SetDacl(dacl);
        CSecurityAttributes sa(sd);

        // Zde vytvome adres s poadovanmi bezpenostnmi atributy.
        if (CreateDirectory("c:\\MyTestDir", &sa))
            cout << "Adres byl vytvoen!" << endl;

    } catch(CAtlException e) {
        cerr << "Chyba  aplikace skonila s chybou " 
            << hex << (HRESULT)e << endl;
    }
}
