/*
  NT4ACL.cpp
*/

#include <windows.h>
#include <stdio.h>
#include <aclapi.h>

void main(){

    PSID pEveryoneSID = NULL, pAdminSID = NULL, pNetworkSID  = NULL;
    PACL pACL = NULL;
    PSECURITY_DESCRIPTOR pSD = NULL;

    // ACL bude obsahovat ti poloky ACE:
    //   Network (Deny Access)
    //   Everyone (Read)
    //   Admin (Full Control)
    try { 
        const int NUM_ACES = 3;
        EXPLICIT_ACCESS ea[NUM_ACES];
        ZeroMemory(&ea, NUM_ACES * sizeof(EXPLICIT_ACCESS)) ;

        // Vytvoen dobe znmho SID pro skupinu Network logon.
        SID_IDENTIFIER_AUTHORITY SIDAuthNT = SECURITY_NT_AU THORITY;
        if (!AllocateAndInitializeSid(&SIDAuthNT, 1,
            SECURITY_NETWORK_RID,
            0, 0, 0, 0, 0, 0, 0,
            &pNetworkSID) ) 
            throw GetLastError();

        ea[0].grfAccessPermissions = GENERIC_ALL;
        ea[0].grfAccessMode = DENY_ACCESS;
        ea[0].grfInheritance= NO_INHERITANCE;
        ea[0].Trustee.TrusteeForm = TRUSTEE_IS_SID;
        ea[0].Trustee.TrusteeType = TRUSTEE_IS_WELL_KNOWN_G ROUP;
        ea[0].Trustee.ptstrName  = (LPTSTR) pNetworkSID;

        // Vytvoen dobe znmho SID pro skupinu Everyone.
        SID_IDENTIFIER_AUTHORITY SIDAuthWorld =
            SECURITY_WORLD_SID_AUTHORITY;
        if (!AllocateAndInitializeSid(&SIDAuthWorld, 1,
            SECURITY_WORLD_RID,
            0, 0, 0, 0, 0, 0, 0,
            &pEveryoneSID) ) 
            throw GetLastError();

        ea[1].grfAccessPermissions = GENERIC_READ;
        ea[1].grfAccessMode = SET_ACCESS;
        ea[1].grfInheritance= NO_INHERITANCE;
        ea[1].Trustee.TrusteeForm = TRUSTEE_IS_SID;
        ea[1].Trustee.TrusteeType = TRUSTEE_IS_WELL_KNOWN_G ROUP;
        ea[1].Trustee.ptstrName  = (LPTSTR) pEveryoneSID;

        // Vytvoen dobe znmho SID pro skupinu BUILTIN\Administrators
        if (!AllocateAndInitializeSid(&SIDAuthNT, 2,
            SECURITY_BUILTIN_DOMA IN_RID,
            DOMAIN_ALIAS_RID_ADMI NS,
            0, 0, 0, 0, 0, 0,
            &pAdminSID) ) 
            throw GetLastError(); 

        ea[2].grfAccessPermissions = GENERIC_ALL;
        ea[2].grfAccessMode = SET_ACCESS;
        ea[2].grfInheritance= NO_INHERITANCE;
        ea[2].Trustee.TrusteeForm = TRUSTEE_IS_SID;
        ea[2].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
        ea[2].Trustee.ptstrName  = (LPTSTR) pAdminSID;

        // Vytvoen novho ACL se temi poadovanmi ACE.
        if (ERROR_SUCCESS != SetEntriesInAcl(NUM_ACES, 
            ea, 
            NULL, 
            &pACL)) 
            throw GetLastError();

        // Inicializace popisovae zabezpeen.  
        pSD = (PSECURITY_DESCRIPTOR) LocalAlloc(LPTR, 
            SECURITY_DESCRIPTOR_MIN_ LENGTH); 
        if (pSD == NULL) 
            throw GetLastError();

        if (!InitializeSecurityDescriptor(pSD, 
            SECURITY_DESCRIPTOR_REVISION))   
            throw GetLastError(); 

        // Do popisovae zabezpeen pidme vytvoen ACL. 
        if (!SetSecurityDescriptorDacl(pSD, 
            TRUE,     // pznak fDaclPresent 
            pACL, 
            FALSE)) {  
                throw GetLastError(); 
            } else {
                SECURITY_ATTRIBUTES sa;
                sa.nLength = sizeof(SECURITY_ATTRIBUTES);
                sa.bInheritHandle = FALSE;
                sa.lpSecurityDescriptor = pSD;

                if (!CreateDirectory("C:\\Program Files\\MyStuff", &sa)) 
                    throw GetLastError();
            } //End try
    } catch(...) {
        // Chybov stav 
    }

    if (pSD) 
        LocalFree(pSD);

    if (pACL)
        LocalFree(pACL);

    // Vyvolme FreeSID pro kad SID, alokovan pi voln
    // AllocateAndInitializeSID.
    if (pEveryoneSID) 
        FreeSid(pEveryoneSID);

    if (pNetworkSID)
        FreeSid(pNetworkSID);

    if (pAdminSID) 
        FreeSid(pAdminSID);
}
