/*
  Restrict.cpp
*/
// Vytvome SID pro skupinu BUILTIN\Administrators.
BYTE sidBuffer[256];
PSID pAdminSID = (PSID)sidBuffer;
SID_IDENTIFIER_AUTHORITY SIDAuth = SECURITY_NT_AUTHORITY;

If (!AllocateAndInitializeSid( &SIDAuth, 2,
                            SECURITY_BUILTIN_DOMAIN_RID ,
                            DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0,
                            &pAdminSID) ) {
    printf( "Chyba AllocateAndInitializeSid %u\n", GetLastError() );
    return -1; 
}

// Zmna SID loklnho administrtora na SID pouze pro odepen.
SID_AND_ATTRIBUTES SidToDisable[1];
SidToDisable[0].Sid = pAdminSID;
SidToDisable[0].Attributes = 0;

// Naten tokenu aktulnho procesu.
HANDLE hOldToken = NULL;
if (!OpenProcessToken(
    GetCurrentProcess(),                   
    TOKEN_ASSIGN_PRIMARY | TOKEN_DUPLICATE | 
    TOKEN_QUERY | TOKEN_ADJUST_DEFAULT, 
    &hOldToken)) { 
    printf("OpenProcessToken selhalo (%lu)\n", GetLastError() );
    return -1; 
}

// Vytvoit omezen token z tokenu procesu.
HANDLE hNewToken = NULL;
if (!CreateRestrictedToken(hOldToken,
    DISABLE_MAX_PRIVILEGE, 
    1, SidToDisable, 
    0, NULL, 
    0, NULL, 
    &hNewToken)) {
    printf("CreateRestrictedToken selhalo (%lu)\n", GetLastError());
    return -1;
}

if (pAdminSID)
    FreeSid(pAdminSID);

// Nsledujc kd vytvo nov proces 
// s omezenm tokenem.
PROCESS_INFORMATION pi;
STARTUPINFO si;
ZeroMemory(&si, sizeof(STARTUPINFO) );
si.cb = sizeof(STARTUPINFO);
si.lpDesktop = NULL;

// Program Cmd.exe spustme z pln cesty, aby se tak
// nemohl spustit trojsk k se stejnm nzvem.
char szSysDir[MAX_PATH+1];
if (GetSystemDirectory(szSysDir, MAX_PATH)) {
    char szCmd[MAX_PATH+1];
    if (StringCchCopy(szCmd,MAX_PATH,szSysDir) == S_OK &&
        StringCchCat(szCmd,MAX_PATH,"\\") == S_OK &&
        StringCchCat(szCmd,MAX_PATH,"cmd.exe") == S_OK) {

            if (!CreateProcessAsUser( 
                hNewToken,
                szCmd, NULL,
                NULL, NULL,
                FALSE, CREATE_NEW_CONSOLE,
                NULL, NULL,  
                &si, &pi))
                printf("CreateProcessAsUser selhalo (%lu)\n", 
                       GetLastError() );
    }
}

CloseHandle(hOldToken);
CloseHandle(hNewToken);
return 0;
