/*
  ProtectKey.cpp
*/
#include "stdafx.h"
using namespace std;

// Nateme symetrick vmnn kl, pomoc kterho zaifrujeme n kl.
void GetExchangeKey(HCRYPTPROV hProv, HCRYPTKEY *hXKey) {
    // Kl pro vmnu kl pochz z vnjho zdroje.
    HCRYPTHASH hHash; 
    BYTE bKey[16];
    if (!GetKeyFromStorage(bKey, sizeof bKey))
        throw GetLastError();

    if (!CryptCreateHash(hProv, CALG_SHA1, 0, 0, &hHash))
        throw GetLastError();

    if (!CryptHashData(hHash, bKey, sizeof bKey, 0))   
        throw GetLastError();

    if (!CryptDeriveKey(hProv, CALG_3DES, hHash, CRYPT_EXPORTABLE, 
                        hXKey))
        throw GetLastError();
}

void main() {

    HCRYPTPROV    hProv = NULL;
    HCRYPTKEY     hKey  = NULL;
    HCRYPTKEY     hExchangeKey  = NULL;
    LPBYTE        pbKey = NULL;

    try {
        if (!CryptAcquireContext(&hProv, NULL, NULL,
                                 PROV_RSA_FULL, 
                                 CRYPT_VERIFYCONTEXT))
            throw GetLastError();

        // Vygenerujeme dva kle 3DES a ozname je jako exportovateln.
        // Poznmka: tyto kle se zde nachzej uvnit CryptoAPI.
        if (!CryptGenKey(hProv, CALG_3DES, CRYPT_EXPORTABLE, &hKey))
            throw GetLastError();

        // Nateme kl, pomoc kterho meme zaifrovat dva kle 3DES.
        GetExchangeKey(hProv, &hExchangeKey);

        // Stanoven velikosti BLOB.
        DWORD dwLen = 0;
        if (!CryptExportKey(hKey, hExchangeKey,
                            SYMMETRICWRAPKEYBLOB, 
                            0, pb Key, &dwLen))
            throw GetLastError();

        pbKey = new BYTE[dwLen]; // Pole pro uloen kl 3DES 
        ZeroMemory(pbKey, dwLen);

        // Nyn nateme skryt BLOB.
        if (!CryptExportKey(hKey, hExchangeKey,
            SYMMETRICWRAPKEYBLOB, 0, pbKey, &dwLen))
            throw GetLastError();

        cout << "Vborn, " << dwLen 
             << " bajt kle je exportovno." 
             << endl;

        // Zapeme skryt kl do Key.bin, podle poteby pepeme
        // namsto opertoru << peme ostream::write(),
        // protoe data mohou obsahovat hodnoty NULL.
        
        ofstream file("c:\\Keys\\key.bin", ios_base::binary);
        file.write(reinterpret_cast<const char *>(pbKey ), dwLen);
        file.close();

    } catch(DWORD e) {
        cerr << "Chyba " << e << hex << " " << e << endl;
    }

    // Zvren klid.
    if (hExchangeKey)   CryptDestroyKey(hExchangeKey);
    if (hKey)           CryptDestroyKey(hKey);
    if (hProv)          CryptReleaseContext(hProv, 0);
    if (pbKey)          delete [] pbKey;
}
