/*
    AcceptConnection.cpp
    Ukzka monost pi spojen
*/

#include <winsock2.h>
#include <assert.h>
#include <stdio.h>
#include "SocketHelper.h"

const char* MyIpAddr = "192.168.0.1";

void OldStyleListen(SOCKET sock)
{
    // Nyn je vytvoena vazba a meme zahjit naslouchn na portu.
    // Promnn je taem spojen.

    int conns = 0;

    while(1)
    {
        // Maximln povolen zpodn (backlog).
        if(listen(sock, SOMAXCONN) == 0)
        {
            SOCKET sock2;
            sockaddr_in from;
            int size;

            // Nkdo se pokusil pipojit  volnm accept zjistme, kdo.
            conns++;

            size = sizeof(sockaddr_in);
            sock2 = accept(sock, (sockaddr*)&from, &size);

            if(sock2 == INVALID_SOCKET)
            {
                printf("Chyba pi pokusu o spojen - %d\n", 
                        GetLastError());
            }
            else
            {
                // POZNMKA: v relnm svt je vhodnj pedat 
                // tento soket do pracovnho vlkna.

                printf("Pijato spojen od %s\n",
                        inet_ntoa(from.sin_addr));
                // Te se rozhodneme, co udlme se spojenm;
                // rozhodovac kritria jsou ale pomrn hloup 
                // a pijmeme kad druh spojen.

                if(conns % 2 == 0)
                {
                    printf("Tento klient je v podku.\n");
                    // Zde meme "pedstrat" zpracovn.
                }
                else
                {
                    printf("Jdi pry!\n");
                }
                closesocket(sock2);
            }
        }
        else
        {
            // Chyba
            printf("Naslouchn selhalo  chyba = %d\n", GetLastError());
            break;
        }

        // Zde doplnme kd, ve kterm se rozhodneme
        // pro ukonen chodu serveru.
        if(conns > 10)
        {
            break;
        }
    }
}

int CALLBACK AcceptCondition(
  IN LPWSABUF lpCallerId,
  IN LPWSABUF lpCallerData,
  IN OUT LPQOS lpSQOS,
  IN OUT LPQOS lpGQOS,
  IN LPWSABUF lpCalleeId,
  OUT LPWSABUF lpCalleeData,
  OUT GROUP FAR *g,
  IN DWORD dwCallbackData
)
{
    sockaddr_in* pCaller;
    sockaddr_in* pCallee;

    pCaller = (sockaddr_in*)lpCallerId->buf;
    pCallee = (sockaddr_in*)lpCalleeId->buf;

    printf("Pokus o spojen od %s\n", 
        inet_ntoa(pCaller->sin_addr));

    // M-li aplikace fungovat pod Windows 98, podvejte se do Q193919.
    if(lpSQOS != NULL)
    {
        // Zde je nutn potvrdit kvalitu sluby QoS.
    }

    // Nyn se rozhodneme, co vrtit. 
    // Spojen od sebe sama nepijmme.
    if(pCaller->sin_addr.S_un.S_addr == inet_addr(MyIpAddr))
    {
        return CF_REJECT;
    }
    else
    {
        return CF_ACCEPT;
    }

    // Mohli bychom vrtit tak kd CF_DEFER. 
    // Tato funkce mus bet ve stejnm vlknu jako volajc.
    // Volajc by na zklad nvratu mohl provst hledn DNS 
    // pot zjistit, kdo ve skutenosti jsme, a zkusit spojen znovu. 

}

void NewStyleListen(SOCKET sock)
{
    // Nyn je vytvoena vazba a meme zahjit naslouchn na portu.
    // Promnn je taem spojen.
    int conns = 0;

    // Nejprve nastavme poadovanou volbu.
    BOOL val = TRUE;
    
    if(setsockopt(sock, 
                  SOL_SOCKET, 
                  SO_CONDITIONAL_ACCEPT, 
                  (const char*)&val, sizeof(val)) != 0)
    {
        printf("Nemohu nastavit SO_CONDITIONAL_ACCEPT  chyba = %d\n", 
                GetLastError());
        return;
    }

    while(1)
    {
        // Maximln povolen zpodn (backlog).
        if(listen(sock, SOMAXCONN) == 0)
        {
            SOCKET sock2;
            sockaddr_in from;
            int size;

            // Nkdo se pokusil pipojit  volnm accept zjistme, kdo.
            conns++;

            size = sizeof(sockaddr_in);

            // Tady se een zan liit.
            sock2 = WSAAccept(sock,
                              (sockaddr*)&from,
                              &size,
                              AcceptCondition,
                              conns); // dal daj pro zptn voln

            if(sock2 == INVALID_SOCKET)
            {
                printf("Chyba pi pokusu o spojen - %d\n", 
                        GetLastError());
            }
            else
            {
                // POZNMKA: v relnm svt je vhodnj pedat 
                // tento soket do pracovnho vlkna.

                printf("Pijato spojen od %s\n",
                        inet_ntoa(from.sin_addr));
                // Zde meme "pedstrat" zpracovn.
                closesocket(sock2);
            }
        }
        else
        {
            // Chyba 
            printf("Naslouchn selhalo  chyba = %d\n", GetLastError());
            break;
        }

        // Zde doplnme kd, ve kterm se rozhodneme
        // pro ukonen chodu serveru.
        if(conns > 10)
        {
            break;
        }
    }
}

int main(int argc, char* argv[])
{
    sockaddr_in addr;
    SOCKET sock;

    if(!InitWinsock())
    {
        printf("Nemohu inicializovat Winsock\n");
        return -1;
    }

    // Pouijeme sten nhodn port, kter by neml bt obsazen.
    if(!InitSockAddr(&addr, "0.0.0.0", 8765))
    {
        printf("Chyba pi nastaven sockaddr\n");
        return -1;
    }

    // Nyn vytvome soket a sveme jej.
    sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

    if(sock == INVALID_SOCKET)
    {
            printf("Nemohu vytvoit soket - err = %d\n", GetLastError());
            return -1;
    }

    if(bind(sock, (sockaddr*)&addr, sizeof(sockaddr_in)) == 0)
    {
            printf("Soket je svzn\n", argv[1]);
    }
    else
    {
            printf("Nemohu svzat soket - err = %d\n", GetLastError());
            closesocket(sock);
            return -1;
    }

    // U jednhoho nebo druhho dku odstrate znak komente 
    // OldStyleListen(sock);
    NewStyleListen(sock);

    closesocket(sock);
    
    return 0;
}
