/*
  BindDemoSvr.cpp
*/
#include <winsock2.h>
#include <stdio.h>
#include <assert.h>
#include "SocketHelper.h"

// Pro star verzi knihovny winsock2.h
#ifndef SO_EXCLUSIVEADDRUSE
#define SO_EXCLUSIVEADDRUSE ((int)(~SO_REUSEADDR))
#endif

/*
  Tato aplikace definuje obecn server nad protokolem UDP.
  Naslouch na portu slo 8391; pokud vm na tomto portu b nco
  jinho, zmte slo portu  a nezapomete provst zmnu i na klientu.
*/

int main(int argc, char* argv[])
{
    SOCKET sock;
    sockaddr_in sin;
    DWORD packets;
    bool hijack = false;
    bool nohijack = false;

    if(argc < 2 || argc > 3)
    {
        printf("Voln je %s [svzan adresa]\n", argv[0]);
        printf("Parametry jsou:\n\t-hijack\n\t-nohijack\n");
        return -1;
    }

    if(argc == 3)
    {
        // Zkontrolovat, jestli je zapnut reim s nosem nebo bez.
        if(strcmp("-hijack", argv[2]) == 0)
        {
            hijack = true;
        }
        else
        if(strcmp("-nohijack", argv[2]) == 0)
        {
            nohijack = true;
        }
        else
        {
            printf("Nerozpoznan argument %s\n", argv[2]);
            return -1;
        }
    }

    if(!InitWinsock())
        return -1;

    // vytvoen soketu.
    sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

    if(sock == INVALID_SOCKET)
    {
        printf("Nemohu vytvoit soket  chyba = %d\n", GetLastError());
        return -1;
    }

    // Nyn sveme soket.
    // Nejprve provedeme inicializaci sockaddr_in.
    // slo portu jsem zde zvolil nahodile, take 
    // by na nm nemlo bet nic jinho.

    if(!InitSockAddr(&sin, argv[1], 8391))
    {
        printf("Nelze inicializovat sockaddr_in - au!\n");
        closesocket(sock);
        return -1;
    }

    // Nyn si ukeme nos i monosti jak mu zabrnit. 
    if(hijack)
    {
        BOOL val = TRUE;
        if(setsockopt(sock, 
                      SOL_SOCKET, 
                      SO_REUSEADDR, 
                      (char*)&val, 
                      sizeof(val)) == 0)
        {
            printf("SO_REUSEADDR zapnuto - Jo Ho Ho\n");
        }
        else
        {
            printf("Nemohu nastavit SO_REUSEADDR  schyba = %d\n", 
                GetLastError());
            closesocket(sock);
            return -1;
        }
    }
    else
    if(nohijack)
    {
        BOOL val = TRUE;
        if(setsockopt(sock, 
                      SOL_SOCKET, 
                      SO_EXCLUSIVEADDRUSE, 
                      (char*)&val, 
                      sizeof(val)) == 0)
        {
            printf("SO_EXCLUSIVEADDRUSE zapnuto\n");
            printf("nos nen povolen!\n");
        }
        else
        {
            printf("Nemohu nastavit SO_REUSEADDR  chyba = %d\n", 
                               GetLastError());
            closesocket(sock);
            return -1;
        }
    }

    if(bind(sock, (sockaddr*)&sin, sizeof(sockaddr_in)) == 0)
    {
        printf("Soket svzn na %s\n", argv[1]);
    }
    else
    {
        if(hijack)
        {
            printf("Zatracen! Pekazili nm plny!\n");
        }

        printf("Nemohu svzat soket - chyba = %d\n", GetLastError());
        closesocket(sock);
        return -1;
    }

    // OK, te je soket svzan. Podvme se, jestli nm nkdo neposl 
    // pakety  nastavme ale asov limit, abychom nemuseli pst 
    // zvltn kd pro ukonen.

    for(packets = 0; packets < 10; packets++)
    {
        char buf[512];
        sockaddr_in from;
        int fromlen = sizeof(sockaddr_in);

        // Nezapomete, e tato funkce vrac TI rzn vsledky: 
        // pokud je vt ne 0, naetli jsme njak data 
        // pokud je roven 0, znamen to regulrn ukonen 
        // (to by se zde nemlo vyskytnout)
        // a pokud je men ne 0, dolo k chyb.

        if(recvfrom(sock, buf, 512, 0, (sockaddr*)&from, &fromlen) > 0)
        {
            printf("Zprva ze %s na portu %d:\n%s\n",
                    inet_ntoa(from.sin_addr),
                    ntohs(from.sin_port),
                    buf);

            // Pokud jsme provedli nos, zmnme zprvu 
            // a odeleme ji na prvoplatn server.

            if(hijack)
            {
                sockaddr_in local;
                if(InitSockAddr(&local, "127.0.0.1", 8391))
                {
                    buf[sizeof(buf)-1] = '\0';
                    strncpy(buf, "Dostal ns hacker!", sizeof(buf) -1);
                    if(sendto(sock, 
                              buf, 
                              strlen(buf) + 1, 0, 
                              (sockaddr*)&local, 
                              sizeof(sockaddr_in)) < 1)
                    {
                    printf(
                      "Nemohu poslat zprvu na localhost  chyba = %d\n",
                    GetLastError());
                    }
                }
            }
        }
        else
        {
            // Netum, jak bychom se sem mohli dostat, ale 
            // kdyby nhodou, udlme regulrn ukonen procesu.
            printf("Neznm chyba%d\n", GetLastError());
            break;
        }
    }

    return 0;

}
