/*
  InternetCrackURL.cpp: Definuje vstupn bod konzolov aplikace.
*/

#include "stdafx.h"

BOOL IsValidDomain(char *szURL, char *szValidDomain, 
                   BOOL fRequireHTTPS) {
    URL_COMPONENTS urlComp;
    ZeroMemory(&urlComp, sizeof(urlComp));
    urlComp.dwStructSize = sizeof(urlComp);

    // Zajm ns pouze hostitelsk nzev 
    char szHostName[128];
    urlComp.lpszHostName = szHostName;
    urlComp.dwHostNameLength = sizeof(szHostName);

    BOOL fRet = InternetCrackUrl(szURL, 0, 0, &urlComp);

    if (fRet==FALSE) {
        printf("InternetCrackURL selhalo -> %d", GetLastError());
        return FALSE;
    }

    // Zkontrolujeme, nen-li vyadovn HTTPS.
    if (fRequireHTTPS && urlComp.nScheme != INTERNET_SCHEME_HTTPS)
        return FALSE;


    // Velice rychl hledn s rozlienm velikosti psmen 
    int cbHostName = lstrlen(urlComp.lpszHostName);
    int cbValid = lstrlen(szValidDomain);
    int cbSize = (cbHostName > cbValid) ? cbValid : cbHostName;
    for (int i=1; i <= cbSize; i++) 
      if (urlComp.lpszHostName[cbHostName-i] != szValidDomain[cbValid-i])
            return FALSE;

    return TRUE;    
}

void main() {
    char *szURL="https://www.northwindtraders.com/foo/default.html";
    char *szValidDomain = "northwindtraders.com";
    BOOL fRequireHTTPS = TRUE;

    if (IsValidDomain(szURL, szValidDomain, TRUE)) {
        printf("Vborn, %s je v platn domn.", szURL);
    }
}
