#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include "phone.h"    // Vygeneroval kompiltor MIDL 
#include <Ntdsapi.h>  // Je poteba pro DsMakeSpn

void Usage() {
    fprintf(stderr, "Voln:  Phonec\n");
    fprintf(stderr, " -p sekvence_protokolu\n");
    fprintf(stderr, " -n sov_adresa\n");
    fprintf(stderr, " -e koncov_bod\n");
    fprintf(stderr, " -o volby\n");
    fprintf(stderr, " -s etzec\n");
    exit(1);
}

void __cdecl main(int argc, unsigned char **argv) {
    LPBYTE pszUuid             = (LPBYTE)NULL;
    LPBYTE pszProtocolSequence = (LPBYTE)"ncacn_np";
    LPBYTE pszNetworkAddress   = (LPBYTE)NULL;
    LPBYTE pszEndpoint         = (LPBYTE)"\\pipe\\phone";
    LPBYTE pszOptions          = (LPBYTE)NULL;
    LPBYTE pszString           = (LPBYTE)"Heslo je $chm0oze";

    // Uivatel me nastaven zmnit pomoc pepna pkazovho dku.
    for (int i = 1; i < argc; i++) {
        if ((*argv[i] == '-') || (*argv[i] == '/')) {
            switch (tolower(*(argv[i]+1))) {
            case 'p':  // Sekvence protokolu 
                pszProtocolSequence = argv[++i];
                break;
            case 'n':  // Sov adresa
                pszNetworkAddress = argv[++i];
                break;
            case 'e':  // Koncov bod
                pszEndpoint = argv[++i];
                break;
            case 'o':
                pszOptions = argv[++i];
                break;
            case 's':
                pszString = argv[++i];
                break;
            case 'h':
            case '?':
            default:
                Usage();
            }
        }
        else
            Usage();
    }

    // Zetzen element etzce vazby do sprvn posloupnosti
    LPBYTE pszStringBinding = (LPBYTE)NULL;
    RPC_STATUS status = RpcStringBindingCompose(pszUuid,
                                     pszProtocolSequence,
                                     pszNetworkAddress,
                                     pszEndpoint,
                                     pszOptions,
                                     &pszStringBinding);
    printf("RpcStringBindingCompose vrtilo 0x%x\n", status);
    printf("pszStringBinding = %s\n", pszStringBinding);
    if (status)
        exit(status);

    // Nastaven popisovae vazby, kter bude definovat svzn se serverem.
 	handle_t hPhone = NULL;
    status = RpcBindingFromStringBinding(pszStringBinding,
                                         &hPhone);
    printf("RpcBindingFromStringBinding vrtilo 0x%x\n", status);
    if (status) 
        exit(status);

	// Zjistit hlavn nzev serveru pro podporu Kerberos.
	DWORD cbSPN = MAX_PATH;
	char szSPN[MAX_PATH + 1];
	status = DsMakeSpn("ldap",
						"blake-laptop.northwindtraders.com",
						NULL,
						0,
						NULL,
						&cbSPN,
						szSPN);

     printf("DsMakeSpn vrtilo 0x%x\n", status);
    if (status) 
        exit(status);

   // Definovat bezpenostn nastaven 
    status = RpcBindingSetAuthInfo(hPhone,
									(LPBYTE)szSPN,
									RPC_C_AUTHN_LEVEL_PKT_PRIVACY,
									RPC_C_AUTHN_GSS_NEGOTIATE,
									0,
									0);
    printf("RpcBindingSetAuthInfo vrtilo 0x%x\n", status);
    if (status)
        exit(status);

    printf("Voln vzdlen procedury 'Message'\n");
    printf("Vpis etzce '%s' na serveru\n", pszString);

	// Vlastn vzdlen voln
    RpcTryExcept {
        Message(hPhone,pszString);  
    }
    RpcExcept(1) {
        ULONG ulCode = RpcExceptionCode();
        printf("Bhov knihovna oznamuje vjimku 0x%lx = %ld\n", ulCode, ulCode);
    }
    RpcEndExcept

    //  Voln vzdlench procedur jsou hotov. 
    //  Uvolnme etzec a popisova vazby. 
    status = RpcStringFree(&pszStringBinding);  
    printf("RpcStringFree vrtilo 0x%x\n", status);
    if (status)
        exit(status);

    status = RpcBindingFree(&hPhone);  
    printf("RpcBindingFree vrtilo 0x%x\n", status);
    if (status) 
        exit(status);

    exit(0);
}  

void  __RPC_FAR * __RPC_USER midl_user_allocate(size_t len) {
    return(malloc(len));
}

void __RPC_USER midl_user_free(void __RPC_FAR * ptr) {
    free(ptr);
}
