# ExerciseArgs.pl

# Tyto parametry podle poteby zmte.
my $exe = "process.exe";
my $iterations = 100;

# Mon typy voleb 
my $NUMERIC = 0;
my $ALPHANUM = 1;
my $PATH = 2;

# Soupis vech monost a typ 
# /p je cesta (path), /i je seln typ a /n je alfanumerick.
my %opts = (
    p => $PATH,
    i => $NUMERIC,
    n => $ALPHANUM);

# Nyn provedeme testy.
for (my $i = 0; $i < $iterations; $i++) {
    print "Iterace $i";

    # Kolik vezmeme argument?
    my $numargs = 1 + int rand scalar %opts;
    print " ($numargs args) ";

    # Sestavme pole s nzvy voleb.
    my @opts2 = ();
    foreach (keys %opts) {
        push @opts2, $_;
    }

    # Sestavme etzec argument.
    my $args = "";
    for (my $j = 0; $j < $numargs; $j++) {
        my $whicharg = @opts2[int rand scalar @opts2];
        my $type = $opts{$whicharg};

        my $arg = "";
        $arg = getTestNumeric() if $type == $NUMERIC;
        $arg = getTestAlphaNum() if $type == $ALPHANUM;
        $arg = getTestPath() if $type == $PATH;

        # formt arg je '/' argname ':' arg
        # pklady: /n:test a /n:42
        $args = $args . " /" . $whicharg . ":$arg";
    }

    # Nyn vyvolme aplikaci s argumenty.
    `$exe $args`;
    $? >>= 8;

    printf "$exe vrtilo $?\n";
}

# Funkce ovlada 

# Vrac seln vsledek testu; 
# z 10% je vsledek nula.
# Jinak je vsledkem hodnota mezi -32000 a 32000.
sub getTestNumeric {
    return rand > .9 
 ? 0 
                : (int rand 32000) - (int rand 32000);
}

# Vrac etzec nhodn dlky. 
sub getTestAlphaNum {
    return 'A' x rand 32000;
}

# Vrac cestu s nkolika adresi o promnn dlce.
sub getTestPath {
    my $path="c:\\";
    for (my $i = 0;  $i < rand 10; $i++) {
        my $seg = 'a' x rand 24;
        $path=$path . $seg . "\\";
    }

    return $path;
}
