/*
   PrintableRand.cpp
*/
#include "windows.h"
#include "wincrypt.h"

DWORD CreateRandomData(LPBYTE lpBuff, DWORD cbBuff, BOOL fPrintable) {
    DWORD dwErr = 0;
    HCRYPTPROV hProv = NULL;

    if (CryptAcquireContext(&hProv, NULL, NULL,
                            PROV_RSA_FULL,
                            CRYPT_VERIFYCONTEXT) == FALSE) 
        return GetLastError();

    ZeroMemory(lpBuff, cbBuff);
    if (CryptGenRandom(hProv, cbBuff, lpBuff)) {
        if (fPrintable) { 
            char *szValid="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                          "abcdefghijklmnopqrstuvwxyz"
                          "0123456789"
                          "~`!@#$%^&*()_- +={}[];:<>,.?|\\/";

            DWORD cbValid = lstrlen(szValid);

            // Nyn kad bajt (0- 255) pevedeme na jin znak
            // z ve uvedenho seznamu platnch znak.
            // Zmrn se dopoutme men chyby, protoe 
            // strlen(szValid) nen pesnm nsobkem 255.

            for (DWORD i=0; i<cbBuff; i++)
                lpBuff[i] = szValid[lpBuff[i] % cbValid];

            // Pokud je etzec tititeln, uzaveme jej.
            // Nen-li etzec tititeln, nebudeme jej nulou ukonovat.
            lpBuff[cbBuff-1] = '\0';
        }
    } else {
        dwErr = GetLastError();
    }

    if (hProv != NULL) 
        CryptReleaseContext(hProv, 0);

    return dwErr;
}

void main(void) {
   BYTE bBuff[16];
   if (CreateRandomData(bBuff, sizeof bBuff, FALSE) == 0) {
            // Vborn, funguje to!
        }
}
