/*
  Tato aplikace pevezme ablonu zabezpeen v souboru .inf,
  zape uivatelem zadan adres do promnn %newapp_install%
  a pot jej zape do vlastnho souboru .inf, kter mete 
  aplikovat na libovoln uivatelem zvolen adres.
*/

#define UNICODE
#include <windows.h>
#include <stdio.h>

/* 
  Hrozn nerad po sob kontroluju vechny cesty v kdu, jestli nkde 
  nenechvm neuklizen popisova, take si radi napu takovouto tdu.
*/
class SmartHandle
{
public:
    SmartHandle()
    {
        Handle = INVALID_HANDLE_VALUE;
    }

    ~SmartHandle()
    {
        if(IsValid())
        {
            CloseHandle(Handle);
        }
    }

    bool IsValid(void)
    {
        if(Handle != INVALID_HANDLE_VALUE &&
            Handle != NULL)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    HANDLE Handle;
};

/*
  Taky vs nebav pevdt argumenty do formtu UNICODE?
  Msto main napite funkci wmain a argumenty se pedaj pmo v UNICODE.
*/

int wmain(int argc, WCHAR* argv[])
{
    SmartHandle hInput;
    SmartHandle hOutput;
    SmartHandle hMap;
    WCHAR* pFile;
    WCHAR* pTmp;
    WCHAR* pLast;
    DWORD filesize;
    DWORD dirlen;

    if(argc != 4)
    {
        wprintf(L"Voln je %s [vstupn soubor]", argv[0]);
        wprintf(L"[vstupn soubor][instalan adres]\n");
        return -1;
    }

    dirlen = wcslen(argv[3]);

    hInput.Handle = CreateFile(argv[1], 
                GENERIC_READ, 
                0,             // Nesdlet soubor
                NULL,          // Nemnit jeho zabezpeen
                OPEN_EXISTING, // Sele, pokud soubor neexistuje
                FILE_ATTRIBUTE_NORMAL, // Bude to normln soubor 
                NULL);         // Ne ablona

    if(!hInput.IsValid())
    {
        wprintf(L"Nemohu otevt %s\n", argv[1]);
        return -1;
    }

    DWORD highsize = 0;
    filesize = GetFileSize(hInput.Handle, &highsize);

    if(highsize != 0 || filesize == ~0)
    {
        // Soubor je vt ne 4 GB - 
        // co je to za nesmysln soubor .inf???
        wprintf(L
        "%s je pli velk, nelze mapovat, nebo velikost nenalezena\n", 
        argv[1]);
        return -1;
    }

    /* 
      Tot jako pedchoz funkce, ale 
      soubor vdy vytvome jako nov 
    */
    hOutput.Handle = CreateFile(argv[2],
                 GENERIC_WRITE,
                 0,
                 NULL,
                 CREATE_ALWAYS,
                 FILE_ATTRIBUTE_NORMAL,
                 NULL);

    if(!hOutput.IsValid())
    {
        wprintf(L"Nemohu otevt %s\n", argv[2]);
        return -1;
    }

    // Te mme oteven vstupn i vstupn soubor, take 
    // meme namapovat zobrazen vstupnho souboru.
    // Soubory mapovan do pamti jsou vborn a hodn operac
    // je s nimi vrazn snazch.

    hMap.Handle = CreateFileMapping(hInput.Handle, // Otevt soubor
                  NULL,          // dn zvltn zabezpeen 
                  PAGE_READONLY, // Pouze pro ten
                  0,             // Maximln velikost neuvedena 
                  0,         // ani minimln vezme se velikost souboru
                  NULL);     // Nzev nepotebujeme 

    if(!hMap.IsValid())
    {
        wprintf(L"Nemohu mapovat %s\n", argv[1]);
        return -1;
    }

    // Zaneme na zatku souboru a mapujeme ho cel.
    pFile = (WCHAR*)MapViewOfFile(hMap.Handle, FILE_MAP_READ, 0, 0, 0);

    if(pFile == NULL)
    {
        wprintf(L"Nemohu mapovat zobrazen %s\n", argv[1]);
        return -1;
    }

    // Te mme ukazatel na cel soubor - 
    // podvme se po poadovanm etzci.

    pTmp = pLast = pFile;
    DWORD subst_len = wcslen(L"%newapp_install%");

    while(1)
    {
        DWORD written, bytes_out;

        pTmp = wcsstr(pLast, L"%newapp_install%");

        if(pTmp != NULL)
        {
            // etzec je nalezen.
            // Kolik bajt budeme zapisovat?

            bytes_out = (pTmp - pLast) * sizeof(WCHAR);

            if(!WriteFile(hOutput.Handle, pLast, bytes_out, 
                &written, NULL) || bytes_out != written)
            {
                wprintf(L"Nemohu zapisovat do %s\n", argv[2]);
                return -1;
            }

            // Te namsto %newapp_install% vypeme skuten adres 
            if(!WriteFile(hOutput.Handle, argv[3], 
                dirlen * sizeof(WCHAR), &written, NULL) ||
                dirlen * sizeof(WCHAR) != written)
            {
                wprintf(L"Nemohu zapisovat do %s\n", argv[2]);
                UnmapViewOfFile(pFile);
                return -1;
            }

            pTmp += subst_len;
            pLast = pTmp;
            }
        else
        {
            // etzec nenalezen  zapeme zbytek souboru.
            bytes_out = (BYTE*)pFile + filesize - (BYTE*)pLast;

            if(!WriteFile(hOutput.Handle, pLast, bytes_out, 
                &written, NULL) || bytes_out != written)
            {
                wprintf(L"Nemohu zapisovat do %s\n", argv[2]);
                UnmapViewOfFile(pFile);
                return -1;
            }
            else
            {
                // A jsme hotovi.
                UnmapViewOfFile(pFile);
                break;
            }
        }
    }

    // Vechny ostatn pepnae se "automagicky" uzavou.
    return 0;
}
